# PSONO - Quickstart

## Canonical source

The canonical source of PSONO Quickstart is [hosted on GitLab.com](https://gitlab.com/psono/psono-quickstart).



## Preamble
This is the PSONO Quickstart project, intended to spin up a demo or development environment in a few seconds.
It is not meant for production use. A couple of reasons why can be found at the end.



## Prerequirements

- Ubuntu 18.04 (Ubuntu 12.04+ LTS and Debian based systems should be similar if not even identical.)
- A domain, pointing to your server. Should match PSONO_WEBDOMAIN in your env file.


## Configuration (optional)
    
Create `~/.psonoenv` to match your setup. If the config does not exist it the script will ask you for the parameters and create the config for you. 
The file could look like this:

    PSONO_VERSION=EE
    PSONO_EXTERNAL_PORT=80
    PSONO_EXTERNAL_PORT_SECURE=443
    PSONO_POSTGRES_PORT=5432
    PSONO_POSTGRES_PASSWORD=PSONO_IS_THE_BEST_OPEN_SOURCE_PASSWORD_MANAGER
    PSONO_USERDOMAIN=localhost
    PSONO_WEBDOMAIN=localhost
    PSONO_POSTGRES_USER=postgres
    PSONO_POSTGRES_DB=postgres
    PSONO_POSTGRES_HOST=postgres

The parameters are.

    PSONO_EXTERNAL_PORT: Usually port 80. Redirects http to https traffic
    PSONO_EXTERNAL_PORT_SECURE: Usually port 443. The actual port serving all the traffic with https.
    PSONO_POSTGRES_PORT: Usually port 5432. Can be used to access the database. Username postgres. Password see variable below.
    PSONO_POSTGRES_PASSWORD: Should be changed to something secure.
    PSONO_USERDOMAIN: The "domain" that will be appended as your username to get the typical email like usernames
    PSONO_PROTOCOL: Usually https://
    PSONO_WEBDOMAIN: Should be the domain (or ip) that you point to this server. If you specified a PSONO_EXTERNAL_PORT_SECURE above different than 443, then your port needs to be part of this parameter e.g. example.com:8443
    PSONO_POSTGRES_USER: The postgres user
    PSONO_POSTGRES_DB: The postgres DB
    PSONO_POSTGRES_HOST: The postgres host


## Install
    
    bash <(curl -s https://gitlab.com/psono/psono-quickstart/raw/master/install.sh)
    
## Control the stack

The script installs an alias for `cd ~/psono/psono-quickstart && docker-compose -f docker-compose-XXX.yml` so you can do for example

    psonoctl up -d

to start the stack or the following

    psonoctl down
    
to stop the stack

## Login

Afterwards you can login here:

    Client URL: https://{{PSONO_WEBDOMAIN}}/
    Admin URL: https://{{PSONO_WEBDOMAIN}}/portal/

User1:

    user: demo1@{{PSONO_USERDOMAIN}}
    pass: demo1

User2:

    user: demo2@{{PSONO_USERDOMAIN}}
    pass: demo2

Admin:

    user: admin@{{PSONO_USERDOMAIN}}
    pass: admin

## Cleanup

First stop the stack with e.g.

    psonoctl down

Afterwards cleanup everything

    rm -Rf ~/psono && \
    rm -Rf ~/.psonoenv && \
    rm -Rf ~/.psono_server_keys && \
    docker system prune --all

## Why only demo purposes?

- This script might harm existing services that are already running on this server.
- The default configs that are generated by this script may contain insecure defaults.
- It uses a docker install script under the hood. The docker guys don't recommend it to be used in production, as it could harm existing services.
- The Database is installed as a docker container. It should be installed on a separate server / vm, separated by a firewall.
- The fileserver is installed as a docker container behind the same domain. It should be installed on a separate host with a separate domain and enough disc capacity, so you don't run out of storage at some point, killing the whole installation.
- If you specify during the installation that you don't want to install ACME, then the script will use self signed certificate and specify that self signed certificates should not throw a validation error, which for a password manager should be considered insecure.
- One would have to validate the nginx config, especially CSP, which at the moment is configured too loose.
- We will adjust this script over time, with potential backward incompatible changes. So if one pulls a new copy, of the script, the server might not start or whatever.
